	/*
C2008 Jim Sager

	   Copyright (C) 2001 by Jorrit Tyberghein

	   This library is free software; you can redistribute it and/or
	   modify it under the terms of the GNU Library General Public
	   License as published by the Free Software Foundation; either
	   version 2 of the License, or (at your option) any later version.

	   This library is distributed in the hope that it will be useful,
	   but WITHOUT ANY WARRANTY; without even the implied warranty of
	   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	   Library General Public License for more details.

	   You should have received a copy of the GNU Library General Public
	   License along with this library; if not, write to the Free
	   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	 */
#ifndef __TextHelper__H__
#define __TextHelper__H__

#include "crystalspace.h"
#include "universals.h"

void blit_text (iImage * dest, e_text e, int posx, int posy);
void blit_text_background (iImage * dest, e_text e, int posx, int posy);


void color_text (e_text & e, int r, int g, int b);
void color_text (e_text & e, int r, int g, int b, int alpha);


//Need ability to change brightness too

void blue_text (e_text & e);
void green_text (e_text & e);
void red_text (e_text & e);
void cyan_text (e_text & e);
void DKcyan_text (e_text & e);
void purple_text (e_text & e);
void DKpurple_text (e_text & e);
void zombie_text (e_text & e);
void ash_text (e_text & e);
void lavendar_text (e_text & e);
void forestgreen_text (e_text & e);
void spewg_text (e_text & e);


void make_background (e_text & e);
void make_background (e_text & e, int r, int g, int b);

int text_width (e_text & e);


#endif
